package com.sleepycat.je;

import com.sleepycat.je.dbi.DatabaseImpl;

public privileged aspect DatabaseStatsInfrastructure {
	
	public DatabaseStats Database.getStats(StatsConfig config) throws DatabaseException {

		checkEnv();
		checkRequiredDbState(OPEN, "Can't call Database.stat");
		StatsConfig useConfig = (config == null) ? StatsConfig.DEFAULT : config;

		if (databaseImpl != null) {
			databaseImpl.checkIsDeleted("stat");
			return databaseImpl.stat(useConfig);
		}
		return null;
	}
	
	private BtreeStats DatabaseImpl.stats; // most recent btree stats w/ !DB_FAST_STAT

}
