
package com.sleepycat.je.tree;

import com.sleepycat.je.dbi.DatabaseImpl;

public privileged aspect DbStatsSupport {

	/**
	 * @return the TreeStats for this tree.
	 */
	TreeStats Tree.getTreeStats() {
		return treeStats;
	}


	private TreeStats Tree.treeStats;

	before(Tree tree):execution(void Tree.init(DatabaseImpl)) && this(tree) {
		tree.treeStats = new TreeStats();
	}

	after(Tree tree):
		execution(void Tree.splitRoot()) && target(tree)
	{
		tree.treeStats.nRootSplits++;
	}
}