package com.sleepycat.je;

public aspect CachingStatsInfrastructure perthis(call(* EnvironmentStats.*(..))) {
	
	/*
	 * Cache
	 */
	private long EnvironmentStats.cacheDataBytes; // part of cache consumed by data, in bytes

	private long EnvironmentStats.nNotResident; // had to be instantiated from an LSN

	private long EnvironmentStats.nCacheMiss; // had to retrieve from disk

	private int EnvironmentStats.nLogBuffers; // number of existing log buffers

	private long EnvironmentStats.bufferBytes; // cache consumed by the log buffers,

	// in bytes


	after (StringBuffer sb, EnvironmentStats es):
		execution(void hook_fillToStringBuffer(StringBuffer)) && args(sb) && this(es){
		
		// Cache
		sb.append("nNotResident=").append(es.nNotResident).append('\n');
		sb.append("nCacheMiss=").append(es.nCacheMiss).append('\n');
		sb.append("nLogBuffers=").append(es.nLogBuffers).append('\n');
		sb.append("bufferBytes=").append(es.bufferBytes).append('\n');
		sb.append("cacheDataBytes=").append(es.cacheDataBytes).append('\n');
		sb.append("cacheTotalBytes=").append(es.getCacheTotalBytes()).append('\n');

	}

	after(EnvironmentStats es):execution(void EnvironmentStats.reset()) && target(es){
		// Cache
		es.cacheDataBytes = 0;
		es.nNotResident = 0;
		es.nCacheMiss = 0;
		es.nLogBuffers = 0;
		es.bufferBytes = 0;

	}
	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getBufferBytes() {
		return bufferBytes;
	}
	
	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getNCacheMiss() {
		return nCacheMiss;
	}


	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public int EnvironmentStats.getNLogBuffers() {
		return nLogBuffers;
	}
	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getCacheTotalBytes() {
		return cacheDataBytes + bufferBytes;
	}

	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getCacheDataBytes() {
		return cacheDataBytes;
	}

	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getNNotResident() {
		return nNotResident;
	}


	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setCacheDataBytes(long cacheDataBytes) {
		this.cacheDataBytes = cacheDataBytes;
	}

	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setNNotResident(long nNotResident) {
		this.nNotResident = nNotResident;
	}

	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setNCacheMiss(long nCacheMiss) {
		this.nCacheMiss = nCacheMiss;
	}

	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setNLogBuffers(int nLogBuffers) {
		this.nLogBuffers = nLogBuffers;
	}

	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setBufferBytes(long bufferBytes) {
		this.bufferBytes = bufferBytes;
	}
	


}
