package com.sleepycat.je;

import com.sleepycat.je.dbi.EnvironmentImpl;
import com.sleepycat.je.dbi.MemoryBudget;
import com.sleepycat.je.*;


public privileged aspect CollectMemoryStats {

	void MemoryBudget.loadStats(StatsConfig config, EnvironmentStats stats) {
		stats.setCacheDataBytes(getCacheMemoryUsage());
	}

	after(StatsConfig config, EnvironmentStats stats, EnvironmentImpl env):
		   execution(void EnvironmentImpl.loadStats(StatsConfig, EnvironmentStats)) 
		   && args(config, stats) && this(env) 
		  {
		stats.setCacheDataBytes(env.getMemoryBudget().getCacheMemoryUsage());
	}

}
