package com.sleepycat.je;

import com.sleepycat.je.log.FileReader;
import com.sleepycat.je.recovery.RecoveryInfo;
import com.sleepycat.je.recovery.RecoveryManager;

//depends on collectRepeatIteratorReads
public privileged aspect RecoveryInfoStats {
	
	// FileReader behavior
	public int RecoveryInfo.nRepeatIteratorReads;

	
	after(StringBuffer sb, RecoveryInfo ri) : 
		execution(void RecoveryInfo.hook_fillToStringBuffer(StringBuffer)) && this(ri) && args(sb) {
	
		sb.append(" nRepeatIteratorReads=").append(ri.nRepeatIteratorReads);
	}


	after(FileReader reader, RecoveryManager rm) : 
		execution(void RecoveryManager.hook_finishedReading(FileReader)) && this(rm) && args(reader) {
	
		rm.info.nRepeatIteratorReads += reader.getNRepeatIteratorReads();
	}

	


}
