package com.sleepycat.je.log;

import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.EnvironmentStats;
import com.sleepycat.je.StatsConfig;
import com.sleepycat.je.dbi.EnvironmentImpl;

public privileged aspect FSyncStatsInfrastructure {
	/*
	 * Stats.
	 */

	private long EnvironmentStats.nFSyncs; // Number of fsyncs issued. May be less than

	// nFSyncRequests because of group commit
	private long EnvironmentStats.nFSyncRequests; // Number of fsyncs requested.

	private long EnvironmentStats.nFSyncTimeouts; // Number of group fsync requests that

	
	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getNFSyncs() {
		return nFSyncs;
	}

	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getNFSyncRequests() {
		return nFSyncRequests;
	}

	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public long EnvironmentStats.getNFSyncTimeouts() {
		return nFSyncTimeouts;
	}
	
	
	
	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setNFSyncs(long val) {
		nFSyncs = val;
	}
	
	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setNFSyncRequests(long val) {
		nFSyncRequests = val;
	}

	/**
	 * Internal use only.
	 */
	public void EnvironmentStats.setNFSyncTimeouts(long val) {
		nFSyncTimeouts = val;
	}
	

	after (StringBuffer sb, EnvironmentStats es):
		execution(* hook_fillToStringBuffer(StringBuffer)) && args(sb) && this(es){
		
		// Cache
		sb.append("nFSyncs=").append(es.nFSyncs).append('\n');
		sb.append("nFSyncRequests=").append(es.nFSyncRequests).append('\n');
		sb.append("nFSyncTimeouts=").append(es.nFSyncTimeouts).append('\n');
	}
	

	after(FileManager fileManager, StatsConfig config, EnvironmentStats stats) throws DatabaseException :
		execution(void FileManager.loadStats(..)) && args(config, stats) && target(fileManager) {
		fileManager.syncManager.loadStats(config, stats);
	}
	

	
	
}
