package com.sleepycat.je;

import com.sleepycat.je.dbi.CursorImpl;
import com.sleepycat.je.dbi.EnvironmentImpl;
import com.sleepycat.je.txn.DummyLockManager;
import com.sleepycat.je.txn.LockManager;

public privileged aspect LockStatsInfrastructure {
	/**
	 * Javadoc for this public method is generated via the doc templates in the
	 * doc_src directory.
	 */
	public LockStats Environment.getLockStats(StatsConfig config) throws DatabaseException {

		checkHandleIsValid();
		checkEnv();
		StatsConfig useConfig = (config == null) ? StatsConfig.DEFAULT : config;

		return environmentImpl.lockStat(useConfig);
	}
	
	/*
	 * For unit tests
	 */
	public LockStats CursorImpl.getLockStats() throws DatabaseException {

		return locker.collectStats(new LockStats());
	}
	
	/**
	 * Retrieve lock statistics
	 */
	synchronized public LockStats EnvironmentImpl.lockStat(StatsConfig config)
			throws DatabaseException {

		return txnManager.lockStat(config);
	}
	
	
	/**
	 * @see LockManager#dumpLockTable
	 */
	public void DummyLockManager.dumpLockTable(LockStats stats) throws DatabaseException {

	}
	
}
