package com.sleepycat.je;

import com.sleepycat.je.log.LogEntryType;
import com.sleepycat.je.dbi.DatabaseImpl.PreloadProcessor;

public privileged aspect CollectPreloadStats {

	private PreloadStats PreloadResult.stats;
	public PreloadStats PreloadResult.getStats(){
		return stats;
	}

	after(PreloadResult pr):execution(PreloadResult.new(..)) && this(pr){
		pr.stats = new PreloadStats();
	}

	after(PreloadProcessor plp, LogEntryType childType):
		execution(* PreloadProcessor.processLSN(..)) && args(*,childType) && this(plp) {
		
		/* Count entry types to return in the PreloadStats. */
		if (childType.equals(LogEntryType.LOG_DUPCOUNTLN_TRANSACTIONAL)
				|| childType.equals(LogEntryType.LOG_DUPCOUNTLN)) {
			plp.preloadResult.stats.nDupCountLNsLoaded++;
		} else if (childType.equals(LogEntryType.LOG_LN_TRANSACTIONAL)
				|| childType.equals(LogEntryType.LOG_LN)) {
			plp.preloadResult.stats.nLNsLoaded++;
		} else if (childType.equals(LogEntryType.LOG_DBIN)) {
			plp.preloadResult.stats.nDBINsLoaded++;
		} else if (childType.equals(LogEntryType.LOG_BIN)) {
			plp.preloadResult.stats.nBINsLoaded++;
		} else if (childType.equals(LogEntryType.LOG_DIN)) {
			plp.preloadResult.stats.nDINsLoaded++;
		} else if (childType.equals(LogEntryType.LOG_IN)) {
			plp.preloadResult.stats.nINsLoaded++;
		}
	}

}
